Loading...
Searching...
No Matches
Dune::ConstArrayListIterator< T, N, A > Class Template Reference
Common

A constant random access iterator for the Dune::ArrayList class. More...

`#include <dune/common/arraylist.hh>`

Inheritance diagram for Dune::ConstArrayListIterator< T, N, A >:

## Public Types

typedef A::value_type | MemberType
| The member type.
typedef A::difference_type | difference_type
typedef A::size_type | size_type
using | reference = typename A::value_type const&
using | const_reference = typename A::value_type const&
using | iterator_category
using | value_type
using | pointer
typedef T | DerivedType
| The type of derived iterator.
typedef const A::value_type | Value
| The type of value accessed through the iterator.
typedef const A::value_type * | Pointer
| The pointer to the Value.
typedef A::difference_type | DifferenceType
| The type of the difference between two positions.
typedef A::value_type const & | Reference
| The type of the reference to the values accessed.

## Public Member Functions

bool | equals (const ConstArrayListIterator< MemberType, N, A > &other) const
| Compares to iterators.
void | increment ()
| Increment the iterator.
void | decrement ()
| decrement the iterator.
void | advance (difference_type n)
difference_type | distanceTo (const ConstArrayListIterator< T, N, A > &other) const
reference | elementAt (size_type i) const
| Get the value of the list at an arbitrary position.
reference | dereference () const
| Access the element at the current position.
| ConstArrayListIterator ()
| ConstArrayListIterator (const ArrayListIterator< T, N, A > &other)
constexpr Reference | operator* () const
| Dereferencing operator.
constexpr Pointer | operator-> () const
constexpr Reference | operator[] (DifferenceType n) const
| Get the element n positions from the current one.
constexpr DerivedType & | operator++ ()
| Preincrement operator.
constexpr DerivedType & | operator+= (DifferenceType n)
constexpr DerivedType | operator+ (DifferenceType n) const
constexpr DerivedType & | operator-- ()
| Predecrement operator.
constexpr DerivedType & | operator-= (DifferenceType n)
constexpr DerivedType | operator- (DifferenceType n) const

## Static Public Attributes

static constexpr int | chunkSize_ = (N > 0) ? N : 1
| The number of elements in one chunk of the list.

## Friends

class | ArrayList< T, N, A >
class | ArrayListIterator< T, N, A >

## Detailed Description

template<class T, int N, class A>
class Dune::ConstArrayListIterator< T, N, A >

A constant random access iterator for the Dune::ArrayList class.

## Member Typedef Documentation

## const_reference

template<class T, int N, class A>

using Dune::ConstArrayListIterator< T, N, A >::const_reference = typename A::value_type const&

## DerivedType

typedef T Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::DerivedType

inherited

The type of derived iterator.

The iterator has to define following functions have to be present:

// Access the value referred to.
Reference dereference() const;
// Access the value at some other location
Reference elementAt(n) const;
// Compare for equality with j
bool equals(j);
// position the iterator at the next element.
void increment()
// position the iterator at the previous element.
void decrement()
// advance the iterator by a number of positions-
void advance(DifferenceType n);
// calculate the distance to another iterator.
// One should incorporate an assertion whether
// the same containers are referenced
DifferenceType distanceTo(j) const;
Dune::ConstArrayListIterator::increment
void increment()
Increment the iterator.
Definition arraylist.hh:603
Dune::ConstArrayListIterator::elementAt
reference elementAt(size_type i) const
Get the value of the list at an arbitrary position.
Definition arraylist.hh:627
Dune::ConstArrayListIterator::dereference
reference dereference() const
Access the element at the current position.
Definition arraylist.hh:639
Dune::ConstArrayListIterator::decrement
void decrement()
decrement the iterator.
Definition arraylist.hh:615
Dune::ConstArrayListIterator::advance
void advance(difference_type n)
Definition arraylist.hh:564
Dune::ConstArrayListIterator::equals
bool equals(const ConstArrayListIterator< MemberType, N, A > &other) const
Compares to iterators.
Definition arraylist.hh:589
Dune::ConstArrayListIterator::distanceTo
difference_type distanceTo(const ConstArrayListIterator< T, N, A > &other) const
Definition arraylist.hh:653
Dune::RandomAccessIteratorFacade< ConstArrayListIterator< T, N, A >, const A::value_type, A::value_type const &, A::difference_type >::DifferenceType
A::difference_type DifferenceType
Definition iteratorfacades.hh:493
Dune::RandomAccessIteratorFacade< ConstArrayListIterator< T, N, A >, const A::value_type, A::value_type const &, A::difference_type >::Reference
A::value_type const & Reference
Definition iteratorfacades.hh:498

For an elaborate explanation see the STL Documentation

## difference_type

template<class T, int N, class A>

typedef A::difference_type Dune::ConstArrayListIterator< T, N, A >::difference_type

## DifferenceType

typedef A::difference_type Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::DifferenceType

inherited

The type of the difference between two positions.

## iterator_category

using Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::iterator_category

inherited

## MemberType

template<class T, int N, class A>

typedef A::value_type Dune::ConstArrayListIterator< T, N, A >::MemberType

The member type.

## Pointer

typedef const A::value_type* Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::Pointer

inherited

The pointer to the Value.

## pointer

using Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::pointer

inherited

## Reference

typedef A::value_type const & Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::Reference

inherited

The type of the reference to the values accessed.

## reference

template<class T, int N, class A>

using Dune::ConstArrayListIterator< T, N, A >::reference = typename A::value_type const&

## size_type

template<class T, int N, class A>

typedef A::size_type Dune::ConstArrayListIterator< T, N, A >::size_type

## Value

typedef const A::value_type Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::Value

inherited

The type of value accessed through the iterator.

## value_type

using Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::value_type

inherited

## Constructor & Destructor Documentation

## ConstArrayListIterator()

template<class T, int N, class A>

Dune::ConstArrayListIterator< T, N, A >::ConstArrayListIterator | ( |  | ) |

inline

## Member Function Documentation

## operator*()

Reference Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator* | ( |  | ) | const

inline constexpr inherited

Dereferencing operator.

## operator+()

DerivedType Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator+ | ( | DifferenceType | n | ) | const

inline constexpr inherited

## operator++()

DerivedType & Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator++ | ( |  | ) |

inline constexpr inherited

Preincrement operator.

## operator+=()

DerivedType & Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator+= | ( | DifferenceType | n | ) |

inline constexpr inherited

## operator-()

DerivedType Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator- | ( | DifferenceType | n | ) | const

inline constexpr inherited

## operator--()

DerivedType & Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator-- | ( |  | ) |

inline constexpr inherited

Predecrement operator.

## operator-=()

DerivedType & Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator-= | ( | DifferenceType | n | ) |

inline constexpr inherited

## operator->()

Pointer Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator-> | ( |  | ) | const

inline constexpr inherited

## operator[]()

Reference Dune::RandomAccessIteratorFacade< T, const A::value_type, A::value_type const &, A::difference_type >::operator[] | ( | DifferenceType | n | ) | const

inline constexpr inherited

Get the element n positions from the current one.

Parameters

  n | The distance to the element.

Returns
  The element at that distance.

## Friends And Related Symbol Documentation

## ArrayList< T, N, A >

template<class T, int N, class A>

friend class ArrayList< T, N, A >

friend

## ArrayListIterator< T, N, A >

template<class T, int N, class A>

friend class ArrayListIterator< T, N, A >

friend

## Member Data Documentation

## chunkSize_

template<class T, int N, class A>

int Dune::ConstArrayListIterator< T, N, A >::chunkSize_ = (N > 0) ? N : 1

static constexpr

The number of elements in one chunk of the list.

This has to be at least one. The default is 100.

The documentation for this class was generated from the following file:

- arraylist.hh